# generated by datamodel-codegen:
#   filename:  schema/entity/services/connections/database/mssqlConnection.json
#   timestamp: 2022-04-05T07:12:48+00:00

from __future__ import annotations

from enum import Enum
from typing import List, Optional

from pydantic import BaseModel, Extra, Field, SecretStr

from . import connectionBasicType


class SupportedPipelineType4(Enum):
    Metadata = 'Metadata'


class MssqlType(Enum):
    MSSQL = 'MSSQL'


class MssqlScheme(Enum):
    mssql_pyodbc = 'mssql+pyodbc'
    mssql_pytds = 'mssql+pytds'
    mssql_pymssql = 'mssql+pymssql'


class MssqlConnection(BaseModel):
    class Config:
        extra = Extra.forbid

    type: Optional[MssqlType] = Field('MSSQL', description='Service Type')
    scheme: Optional[MssqlScheme] = Field(
        'mssql+pyodbc', description='SQLAlchemy driver scheme options.'
    )
    username: Optional[str] = Field(
        None,
        description='username to connect  to the MsSQL. This user should have privileges to read all the metadata in MsSQL.',
    )
    password: Optional[SecretStr] = Field(
        None, description='password to connect  to the MsSQL.'
    )
    hostPort: Optional[str] = Field(None, description='Host and port of the MsSQL.')
    database: Optional[str] = Field(
        None,
        description='Database of the data source. This is optional parameter, if you would like to restrict the metadata reading to a single database. When left blank , OpenMetadata Ingestion attempts to scan all the databases in MsSQL.',
    )
    connectionOptions: Optional[connectionBasicType.ConnectionOptions] = None
    connectionArguments: Optional[connectionBasicType.ConnectionArguments] = None
    supportedPipelineTypes: Optional[List[SupportedPipelineType4]] = Field(
        ['Metadata'], description='Supported Metadata Extraction Pipelines.'
    )
